# all files / src/ windows.js

95.24% Statements 20/21
90.91% Branches 10/11
88.89% Functions 8/9
95.24% Lines 20/21

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128

    1×
    10×
    1×
    1×
    1×

    10×

    1×
    1×

    1×

    1×
    2×

    2×

    1×
    2×

    2×

    2×
    2×

    2×

    2×
    2×

     /**
     * @class OO.ui
     */

    /**
     * Lazy-initialize and return a global OO.ui.WindowManager instance, used by OO.ui.alert and
     * OO.ui.confirm.
     *
     * @private
     * @return {OO.ui.WindowManager}
     */
    OO.ui.getWindowManager = function () {
    	if ( !OO.ui.windowManager ) {
    		OO.ui.windowManager = new OO.ui.WindowManager();
    		$( 'body' ).append( OO.ui.windowManager.$element );
    		OO.ui.windowManager.addWindows( [ new OO.ui.MessageDialog() ] );
    	}
    	return OO.ui.windowManager;
    };

    /**
     * Display a quick modal alert dialog, using a OO.ui.MessageDialog. While the dialog is open, the
     * rest of the page will be dimmed out and the user won't be able to interact with it. The dialog
     * has only one action button, labelled "OK", clicking it will simply close the dialog.
     *
     * A window manager is created automatically when this function is called for the first time.
     *
     *     @example
     *     OO.ui.alert( 'Something happened!' ).done( function () {
     *         console.log( 'User closed the dialog.' );
     *     } );
     *
     *     OO.ui.alert( 'Something larger happened!', { size: 'large' } );
     *
     * @param {jQuery|string} text Message text to display
     * @param {Object} [options] Additional options, see OO.ui.MessageDialog#getSetupProcess
     * @return {jQuery.Promise} Promise resolved when the user closes the dialog
     */
    OO.ui.alert = function ( text, options ) {
    	return OO.ui.getWindowManager().openWindow( 'message', $.extend( {
    		message: text,
    		actions: [ OO.ui.MessageDialog.static.actions[ 0 ] ]
    	}, options ) ).closed.then( function () {
    		return undefined;
    	} );
    };

    /**
     * Display a quick modal confirmation dialog, using a OO.ui.MessageDialog. While the dialog is open,
     * the rest of the page will be dimmed out and the user won't be able to interact with it. The
     * dialog has two action buttons, one to confirm an operation (labelled "OK") and one to cancel it
     * (labelled "Cancel").
     *
     * A window manager is created automatically when this function is called for the first time.
     *
     *     @example
     *     OO.ui.confirm( 'Are you sure?' ).done( function ( confirmed ) {
     *         if ( confirmed ) {
     *             console.log( 'User clicked "OK"!' );
     *         } else {
     *             console.log( 'User clicked "Cancel" or closed the dialog.' );
     *         }
     *     } );
     *
     * @param {jQuery|string} text Message text to display
     * @param {Object} [options] Additional options, see OO.ui.MessageDialog#getSetupProcess
     * @return {jQuery.Promise} Promise resolved when the user closes the dialog. If the user chose to
     *  confirm, the promise will resolve to boolean `true`; otherwise, it will resolve to boolean
     *  `false`.
     */
    OO.ui.confirm = function ( text, options ) {
    	return OO.ui.getWindowManager().openWindow( 'message', $.extend( {
    		message: text
    	}, options ) ).closed.then( function ( data ) {
    		return !!( data && data.action === 'accept' );
    	} );
    };

    /**
     * Display a quick modal prompt dialog, using a OO.ui.MessageDialog. While the dialog is open,
     * the rest of the page will be dimmed out and the user won't be able to interact with it. The
     * dialog has a text input widget and two action buttons, one to confirm an operation (labelled "OK")
     * and one to cancel it (labelled "Cancel").
     *
     * A window manager is created automatically when this function is called for the first time.
     *
     *     @example
     *     OO.ui.prompt( 'Choose a line to go to', { textInput: { placeholder: 'Line number' } } ).done( function ( result ) {
     *         if ( result !== null ) {
     *             console.log( 'User typed "' + result + '" then clicked "OK".' );
     *         } else {
     *             console.log( 'User clicked "Cancel" or closed the dialog.' );
     *         }
     *     } );
     *
     * @param {jQuery|string} text Message text to display
     * @param {Object} [options] Additional options, see OO.ui.MessageDialog#getSetupProcess
     * @param {Object} [options.textInput] Additional options for text input widget, see OO.ui.TextInputWidget
     * @return {jQuery.Promise} Promise resolved when the user closes the dialog. If the user chose to
     *  confirm, the promise will resolve with the value of the text input widget; otherwise, it will
     *  resolve to `null`.
     */
    OO.ui.prompt = function ( text, options ) {
    	var instance,
    		manager = OO.ui.getWindowManager(),
    		textInput = new OO.ui.TextInputWidget( ( options && options.textInput ) || {} ),
    		textField = new OO.ui.FieldLayout( textInput, {
    			align: 'top',
    			label: text
    		} );

    	instance = manager.openWindow( 'message', $.extend( {
    		message: textField.$element
    	}, options ) );

    	// TODO: This is a little hacky, and could be done by extending MessageDialog instead.
    	instance.opened.then( function () {
    		textInput.on( 'enter', function () {
    			manager.getCurrentWindow().close( { action: 'accept' } );
    		} );
    		textInput.focus();
    	} );

    	return instance.closed.then( function ( data ) {
    		return data && data.action === 'accept' ? textInput.getValue() : null;
    	} );
    };